import numpy as np
import pylab as pl
import os

DSL = "data/windows_24x24" # "windows_24x24" # "test"  # str or None

T = 20000
dims = (24,24)



# Check for existing data set
if DSL is not None:
    outfilename = DSL + ".npy"
    if os.path.exists(outfilename):
        raise Exception, "FILENAME ERROR: " + outfilename + " already exists!"


l1,l2 = dims
feat = np.array([[(i%3==0) or (j%3==0) for i in range(l1) for j in range(l2)],
                 [(i+j)/2 % 2 for i in range(l1) for j in range(l2)],
                 [(i+j) % 2 for i in range(l1) for j in range(l2)]]).reshape(-1,*dims)



window = np.array([[[0,0,0,0,0,0,1,1,1,0,0,0,0,0,0],
                    [0,0,0,0,1,1,1,1,1,1,1,0,0,0,0],
                    [0,0,0,1,1,1,1,1,1,1,1,1,0,0,0],
                    [0,0,1,1,1,1,1,1,1,1,1,1,1,0,0],
                    [0,1,1,1,1,1,1,1,1,1,1,1,1,1,0],
                    [0,1,1,1,1,1,1,1,1,1,1,1,1,1,0],
                    [1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],
                    [1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],
                    [1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],
                    [0,1,1,1,1,1,1,1,1,1,1,1,1,1,0],
                    [0,1,1,1,1,1,1,1,1,1,1,1,1,1,0],
                    [0,0,1,1,1,1,1,1,1,1,1,1,1,0,0],
                    [0,0,0,1,1,1,1,1,1,1,1,1,0,0,0],
                    [0,0,0,0,1,1,1,1,1,1,1,0,0,0,0],
                    [0,0,0,0,0,0,1,1,1,0,0,0,0,0,0]],
                   [[0,0,1,1,1,1,1,0,0,0,0,0,0,0,0],
                    [0,1,1,1,1,1,1,1,1,1,0,0,0,0,0],
                    [1,1,1,1,1,1,1,1,1,1,1,1,0,0,0],
                    [1,1,1,1,1,1,1,1,1,1,1,1,1,0,0],
                    [1,1,1,1,1,1,1,1,1,1,1,1,1,0,0],
                    [1,1,1,1,1,1,1,1,1,1,1,1,1,1,0],
                    [1,1,1,1,1,1,1,1,1,1,1,1,1,1,0],
                    [1,1,1,1,1,1,1,1,1,1,1,1,1,1,0],
                    [0,1,1,1,1,1,1,1,1,1,1,1,1,0,0],
                    [0,1,1,1,1,1,1,1,1,1,1,1,1,0,0],
                    [0,0,1,1,1,1,1,1,1,1,1,1,0,0,0],
                    [0,0,1,1,1,1,1,1,1,1,1,0,0,0,0],
                    [0,0,1,1,1,1,1,1,1,1,1,0,0,0,0],
                    [0,0,0,1,1,1,1,1,1,1,0,0,0,0,0],
                    [0,0,0,0,0,1,1,1,0,0,0,0,0,0,0]],
                   [[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
                    [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
                    [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
                    [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
                    [0,0,0,0,0,1,1,1,1,1,0,0,0,0,0],
                    [0,0,0,0,1,1,1,1,1,1,1,0,0,0,0],
                    [0,0,0,1,1,1,1,1,1,1,1,1,1,0,0],
                    [0,1,1,1,1,1,1,1,1,1,1,1,1,1,0],
                    [1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],
                    [1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],
                    [1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],
                    [0,1,1,1,1,1,1,1,1,1,1,1,1,1,0],
                    [0,1,1,1,1,1,1,1,1,1,1,1,1,0,0],
                    [0,0,0,1,1,1,1,1,1,1,1,1,0,0,0],
                    [0,0,0,0,0,1,1,1,1,1,0,0,0,0,0]],
                   [[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
                    [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
                    [0,0,0,0,1,1,1,1,0,0,0,0,0,0,0],
                    [0,0,0,1,1,1,1,1,1,0,0,0,0,0,0],
                    [0,0,1,1,1,1,1,1,1,1,0,0,0,0,0],
                    [0,0,0,1,1,1,1,1,1,1,1,1,0,0,0],
                    [0,0,0,0,1,1,1,1,1,1,1,1,1,0,0],
                    [0,0,0,0,1,1,1,1,1,1,1,1,1,1,0],
                    [0,0,0,0,1,1,1,1,1,1,1,1,1,1,0],
                    [0,0,0,0,1,1,1,1,1,1,1,1,1,1,1],
                    [0,0,0,1,1,1,1,1,1,1,1,1,1,1,1],
                    [0,0,1,1,1,1,1,1,1,1,1,1,1,1,0],
                    [0,0,1,1,1,1,1,1,1,1,1,1,1,0,0],
                    [0,0,0,1,1,1,1,1,1,1,1,1,0,0,0],
                    [0,0,0,0,1,1,1,1,1,1,1,0,0,0,0]]], dtype=bool)





def random_window(): 
    wn,wx,wy = window.shape
    w = np.zeros(dims, dtype=bool)
    w[:wx,:wy] = window[np.random.randint(wn)]
    rx,ry = np.random.randint(dims[0]), np.random.randint(dims[1])
    w = np.roll(w, rx, 0)
    w = np.roll(w, ry, 1)
    return w         


def draw_valid_windows():
    w1 = random_window()
    w2 = w1
    while (w1 * w2).any():
        w2 = random_window()
    return w1,w2


def draw_template():
    nf = feat.shape[0]
    i1,i2 = np.random.randint(0,nf,2)
    x = np.zeros(dims)
    w1,w2 = draw_valid_windows()
    x[:] = w1*feat[i1] + w2*feat[i2]
    return x


X = np.zeros((T,)+dims)
for t in xrange(T):
    X[t] = draw_template()


# save results
if DSL is not None:
    print "\n > Save data set to", outfilename
    np.save(outfilename, X)
else:
    print " > WARNING: Testrun!"
print " > Done."
