import numpy as _np
from matplotlib import cm as _cm
from matplotlib.colors import ColorConverter as _CC

_cc = _CC()

# color definitions for plot scripts

input_neuron = "#cbecbd"
input_highlight = "#99da7d"
input_spikebg = "#e8ffdb"  # 1. - 0.67 * (1. - _np.array(_cc.to_rgb(input_neuron)))

network_neuron = "#f8dec7"
network_highlight = "#efab71"
network_extra_highlight = "#965011"
network_spikebg = "#ffe0cc"  # 1. - 1.0 * (1. - _np.array(_cc.to_rgb(network_neuron)))


select = dict(red = "#ff0000",
              green = "#12a420",
              blue = "#2b2fe8",
              cyan = "#0ddfe1",
              yellow = "#c79900",
              magenta = "#ef00f0",)


# colormaps

# input
_r1,_g1,_b1, = _np.array(_cc.to_rgb("#cee6c1")) # 1. - 1. * (1. - _np.array(_cc.to_rgb(input_spikebg)))
_r2,_g2,_b2, = _np.array(_cc.to_rgb("#adadad"))  #518a33
_input_cdict = {'red':((0.0, 1., 1.),
                       (0.1, _r1, _r1),
                       (0.3, _r2, _r2),
                      (1.0,  0., 0.)),
            'green': ((0.0, 1., 1.),
                       (0.1, _g1, _g1),
                       (0.3, _g2, _g2),
                      (1.0,  0., 0.)),
             'blue': ((0.0, 1., 1.),
                       (0.1, _b1, _b1),
                       (0.3, _b2, _b2),
                      (1.0,  0., 0.))}
_cm.register_cmap(name='gwta_input', data=_input_cdict)

# input2
_r1,_g1,_b1, = _np.array(_cc.to_rgb("#97dd7d")) #acc7a2
_r2,_g2,_b2, = _np.array(_cc.to_rgb("#577757"))  #518a33 #575757
_input_cdict = {'red':((0.0, 1., 1.),
                       (0.35, _r1, _r1),
                       (0.65, _r2, _r2),
                      (1.0,  0., 0.)),
            'green': ((0.0, 1., 1.),
                       (0.35, _g1, _g1),
                       (0.65, _g2, _g2),
                      (1.0,  0., 0.)),
             'blue': ((0.0, 1., 1.),
                       (0.35, _b1, _b1),
                       (0.65, _b2, _b2),
                      (1.0,  0., 0.))}
_cm.register_cmap(name='gwta_input2', data=_input_cdict)


# network
_r1,_g1,_b1, = _np.array(_cc.to_rgb("#ffeadb")) #   1. - 1.0 * (1. - _np.array(_cc.to_rgb(network_spikebg)))
_r2,_g2,_b2, = _np.array(_cc.to_rgb("#adadad")) 
_network_cdict = {'red':((0.0, _r1, _r1),
                       (0.0, _r1, _r1),
                       (0.3, _r2, _r2),
                      (1.0,  0., 0.)),
            'green': ((0.0, _g1, _g1),
                       (0.0, _g1, _g1),
                       (0.3, _g2, _g2),
                      (1.0,  0., 0.)),
             'blue': ((0.0, _b1, _b1),
                       (0.0, _b1, _b1),
                       (0.3, _b2, _b2),
                      (1.0,  0., 0.))}
_cm.register_cmap(name='gwta_network', data=_network_cdict)


# afferent weight
#_r1,_g1,_b1, = _np.array(_cc.to_rgb("#b7bbeb"))
#_r2,_g2,_b2, = _np.array(_cc.to_rgb("#32398a")) 
#_weight_cdict = {'red':((0.0, 1., 1.),
                       #(0.2, 1., 1.),
                       ##(0.4, 0.6, 0.6),
                      #(1.0,  0., 0.)),
            #'green': ((0.0, 1., 1.),
                       #(0.3, 0.6, 0.6),
                       #(0.4, 0.6, 0.6),
                      #(1.0,  0., 0.)),
             #'blue': ((0.0, 1., 1.),
                       #(0.15, 0.6, 0.6),
                       #(0.4, 0.6, 0.6),
                      #(1.0,  0., 0.))}
#_cm.register_cmap(name='gwta_weight', data=_weight_cdict)



input_cmap = _cm.get_cmap('gwta_input')
input2_cmap = _cm.get_cmap('gwta_input2')
network_cmap = _cm.get_cmap('gwta_network')
weight_cmap = _cm.get_cmap("gist_heat_r") # _cm.get_cmap("gwta_weight") # _cm.get_cmap("gist_heat_r")


