import numpy as np
import pylab as pl

def ax_coords(layout, sub):
    R,C = layout.shape
    d0,d1 = (layout == sub).nonzero()
    x0,x1 = d1.min(), d1.max()
    y0,y1 = R-1-d0.max(), R-1-d0.min()
    x,y = (x0+0.2) / C, (y0+0.2) / R
    w = (x1-x0+0.65) / C
    h = (y1-y0+0.65) / R
    rect = (x, y, w, h)
    return rect


def build_fig(figsize, layout):
    pl.interactive(False)
    layout = np.array(layout, dtype=int)
    subs = np.unique(layout)
    N = len(subs)
    fig = pl.figure(figsize=figsize)
    axes = dict()
    for sub in subs:
        rect = ax_coords(layout, sub)
        ax = fig.add_axes(rect)
        axes[sub] = ax
    pl.interactive(True)
    return (fig, axes)
